#include "mainwindow.h"
#include "ui_mainwindow.h"

#define Quat 16
#define RPY 12  // byte number to read after detected 4 0's.
#define CLAMP(x , min , max) ((x) > (max) ? (max) : ((x) < (min) ? (min) : x))

float ROLL,PITCH,YAW;
extern QTimer timer_update;
extern QTimer timer_update2;
bool turn=false;
bool act = false;
float hex2float(QByteArray array);
char cmd[16];

int cur=0;
buffer* buf1 = new buffer;
buffer* cur_buf = buf1;
int num_buf=1;

qint16 read_buff;
qint16 read_rest;

long int count=0; //number of data in buffer

//for the stupid bad documented QWT plot
long int count_up=0;
QVector<QPointF>* samples = new QVector<QPointF>;
QwtPointSeriesData* x_data = new QwtPointSeriesData;
QVector<QPointF>* ysamples = new QVector<QPointF>;
QwtPointSeriesData* y_data = new QwtPointSeriesData;


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    timer_read = new QTimer(this);
    connect(timer_read,SIGNAL(timeout()),this,SLOT(readComPort()));
    timer_write = new QTimer(this);
    connect(timer_write,SIGNAL(timeout()),this,SLOT(send_cmd()));

    roll = 0;
    pitch = 0;
    yaw = 0;

    count=0;

    d_plot = new plot;
    count_up=0;
    samples->clear();
    ysamples->clear();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::readComPort()
{

    if(ComPort->bytesAvailable()>0)
    {
        QByteArray array;
        QByteArray str00 = "00000000";
        temp = ComPort->read(4);
        temp = temp.toHex();

        if ( temp == str00)
        {
            array = ComPort->read(4);
            array = array.toHex();
           // qDebug()<<"roll is"<<array;
            roll = hex2float(array); //x
            array.clear();

            array = ComPort->read(4);
            array = array.toHex();
           // qDebug()<<"pitch is"<<array;
            yaw = 0-hex2float(array); //y
            array.clear();

            array = ComPort->read(4);
            array = array.toHex();
          //  qDebug()<<"yaw is"<<array;
            pitch = hex2float(array); //z
            array.clear();

            /*
            w = QString::number( roll,'f', 5 );
            x = QString::number( pitch,'f', 5 );
            y = QString::number( yaw,'f', 5 );
            */
            //store data into a linked buffer;
            memcpy(cur_buf->buf+cur,&roll,4);
            cur += 4;
            if(cur==1024)
            {
                cur_buf->next = new buffer;
                cur_buf = cur_buf->next;
                cur=0;
                num_buf++;
            }
            memcpy(cur_buf->buf+cur,&pitch,4);
            cur += 4;
            if(cur==1024)
            {
                cur_buf->next = new buffer;
                cur_buf = cur_buf->next;
                cur=0;
                num_buf++;
            }
            memcpy(cur_buf->buf+cur,&yaw,4);
            cur += 4;
            if(cur==1024)
            {
                cur_buf->next = new buffer;
                cur_buf = cur_buf->next;
                cur=0;
                num_buf++;
            }
            count+=3;
            /*
            QByteArray count_ch;
            count_ch.setNum(count,10); //integrate time with sensor data
            */
           // ui->textBrowser->insertPlainText(/*count_ch+"\n"+*/w+" "+x+" "+y+" ");

            ROLL =roll;
            PITCH = pitch;
            YAW = yaw;

            //put data into plot

            count_up++;
            samples->push_back(QPointF(count_up,ROLL));
            ysamples->push_back(QPointF(count_up,-YAW));

            x_data->setSamples(*samples);
            y_data->setSamples(*ysamples);
            ui->qwtwidget->curvex->setData(x_data);
            ui->qwtwidget->curvey->setData(y_data);
            if(count_up>1000)
            {
                samples->clear();
                ysamples->clear();
                count_up=0;
            }
            ui->qwtwidget->replot();

        }
    ComPort->flush();
    }

}

void MainWindow::on_actionConnect_triggered()
{
    struct PortSettings ComSetting = {BAUD115200,DATA_8,PAR_NONE,STOP_1,FLOW_OFF,500};
    ComPort = new Win_QextSerialPort("\\\\.\\COM9",ComSetting,QextSerialBase::EventDriven);
    ComPort->open(QIODevice::ReadWrite);

    ui->actionDisconnect->setEnabled(true);
    ui->actionConnect->setEnabled(false);
    ui->playback->setEnabled(false);

    timer_read->start(10);
    timer_write->start(50);
    timer_update.start(100);
    timer_update2.start(100);
    count=0;

    ui->textBrowser->insertPlainText("Successfully connected\n");
}

void MainWindow::on_actionDisconnect_triggered()
{
    ComPort->close();
    ui->actionConnect->setEnabled(true);
    ui->actionDisconnect->setEnabled(false);
    ui->playback->setEnabled(true);
    timer_read->stop();
    timer_write->stop();
    timer_update.stop();
    timer_update2.stop();
    cur=0;
    cur_buf = buf1;
    qDebug()<<"count is:"<<count;
    ui->textBrowser->insertPlainText("Successfully disconnected\n");
}

void MainWindow::on_actionSave_triggered()
{
    QString fileName = QFileDialog::getSaveFileName(this, tr("Save File"), "",
            tr("ECE445 Files (*.ECE445)"));

           if (fileName != "")
           {
                QFile file(fileName);
                if (!file.open(QIODevice::WriteOnly))
                {
                     QMessageBox::critical(this, tr("Error"), tr("Could not save file"));
                     return;
                }
                else {
                   // QTextStream stream(&file);
                    //QString tosave_str(ToSave);

                    qDebug()<<"tosave:count"<<count;
                    read_buff = count*4/1024;
                    read_rest = (count*4)%1024;

                    if(read_rest==0)
                        if(read_buff!=num_buf)
                            qDebug()<<"rest =0 read_buff not match";
                        else
                            qDebug()<<"buffer number match";
                    else
                        if(read_buff!=num_buf-1)
                            qDebug()<<"rest!=0 read_buff not match";
                        else
                            qDebug()<<"buffer number match";

                    //store number of filled buffers and the filled byte in the unfilled buffer

                    const char read_buff_const_h = (char)((read_buff&0xff00) >>8);
                    const char read_buff_const_l = (char)(read_buff&0x00ff);
                    const char read_rest_const_h = (char)((read_rest&0xff00) >>8);
                    const char read_rest_const_l = (char)(read_rest&0x00ff);


                    file.write(&read_buff_const_h,1);
                    file.write(&read_buff_const_l,1);
                    file.write(&read_rest_const_h,1);
                    file.write(&read_rest_const_l,1);

                    cur_buf = buf1;
                    char *read_temp;
                    read_temp = new char[1024];

                    for(int i=0;i<read_buff;i++)
                    {
                        memcpy(read_temp,cur_buf->buf,1024);
                        if(cur_buf->next!=NULL)
                            cur_buf = cur_buf->next;
                        file.write(read_temp,1024);
                    }
                    qDebug()<<"read 1024";
                    char* read_temp1 = new char[read_rest];
                    qDebug()<<"pass 231";
                    memcpy(read_temp1,cur_buf->buf,read_rest);
                    qDebug()<<"pass 233";
                    file.write(read_temp1,read_rest);
                    qDebug()<<"pass 235";
                    //stream << ui->textBrowser->toPlainText();
                    //stream.flush();
                    file.close();
                }
                ui->textBrowser->insertPlainText("File Saved!\n");
            }

}

void MainWindow::on_actionOpen_triggered()
{
    QString fileName = QFileDialog::getOpenFileName(this, tr("Open File"), "",
                tr("ECE445 Files (*.ECE445)"));

        if (fileName != "") {
            QFile file(fileName);
            if (!file.open(QIODevice::ReadOnly)) {
                QMessageBox::critical(this, tr("Error"), tr("Could not open file"));
                return;
            }

            char read_buff_temp_h;
            char read_buff_temp_l;

            char read_rest_temp_h;
            char read_rest_temp_l;

            file.read(&read_buff_temp_h,1);
            file.read(&read_buff_temp_l,1);
            file.read(&read_rest_temp_h,1);
            file.read(&read_rest_temp_l,1);

            read_buff = ((qint16)read_buff_temp_h)<<8 | read_buff_temp_l;
            read_rest = ((qint16)read_rest_temp_h)<<8 | read_rest_temp_l;

            qDebug()<<"read_buf"<<read_buff<<"read_rest"<<read_rest;

            count = (read_buff*1024 + read_rest)/4;

            //calculate number of buffers to allocate
            if(read_rest==0)
                num_buf=read_buff;
            else
                num_buf = read_buff+1;

            //start allocate new linked buffer
            cur_buf = buf1;
            for(int i=1;i<num_buf;i++)
            {
                cur_buf->next = new buffer;
                cur_buf = cur_buf->next;
            }
            cur_buf = buf1;
            for(int i=0;i<read_buff;i++)
            {
                file.read(cur_buf->buf,1024);
                if(cur_buf->next!=NULL)
                    cur_buf = cur_buf->next;
            }
            file.read(cur_buf->buf,read_rest);
            /*
            QTextStream in(&file);
            ui->textBrowser->insertPlainText(in.readAll());*/
            file.close();
        }
        samples->clear();
        ysamples->clear();
        ui->textBrowser->insertPlainText("File Opened\n");
}

void MainWindow::on_actionQuit_triggered()
{
    /*
    cur_buf = buf1;
    buffer* next_buf;
    for(int i=0;i<num_buf;i++)
    {
        if(cur_buf->next!=NULL)
            next_buf = cur_buf->next;
        delete cur_buf;
        cur_buf = next_buf;
    }
    */
    close();
}

 void MainWindow::quat2euler(float wf,float xf, float yf, float zf, float *roll, float *pitch, float *yaw)
{
    *roll = atan2(2 * (wf * zf + xf * yf) , 1 - 2 * (zf * zf + xf * xf));
    *pitch = asin(CLAMP(2 * (wf * xf - yf * zf) , -1.0f , 1.0f));
    *yaw = atan2(2 * (wf * yf + zf * xf) , 1 - 2 * (xf * xf + yf * yf));
}

 float hex2float(QByteArray array)
 {
     bool ok;
     int sign = 1;
    // QByteArray array("425AE78F"); 54.72613
     array = QByteArray::number(array.toLongLong(&ok,16),2); //convert hex to binary -you don't need this since your incoming data is binary
     if(array.length()==32)
     {
         if(array.at(0)=='1')
             sign =-1;                       // if bit 0 is 1 number is negative
         array.remove(0,1);                                     // remove sign bit
     }
     QByteArray fraction =array.right(23);   //get the fractional part
     double mantissa = 0;
     for(int i=0;i<fraction.length();i++)     // iterate through the array to claculate the fraction as a decimal.
         if(fraction.at(i)=='1')
             mantissa += 1.0/(pow(2.0,i+1));
     int exponent = array.left(array.length()-23).toLongLong(&ok,2)-127;     //claculate the exponent
    // qDebug() << "number= "<< QString::number( sign*pow(2.0,exponent)*(mantissa+1.0),'f', 5 );
     return sign*pow(2.0,exponent)*(mantissa+1.0);

 }

void MainWindow::on_clsc_clicked()
{
    ui->textBrowser->clear();
}

void MainWindow::send_cmd()
{

    // 0 0 0 0 + 1 forward/2 backward/3 left turn/4 right turn/f stop + position
    for(int i=0;i<4;i++)
    {
        cmd[i]=(char)0xff;
    }
    if(act)
    {
        act = false;
        if(ui->checkBox->isChecked())
        {
            cmd[4] = 5;
            cmd[5] = 1;
            cmd[6] = 0;
        }
        else
        {
            cmd[4] = 5;
            cmd[5] = 0;
            cmd[6] = 0;
        }
    }
    else
    {
        if (turn)
        {
            qint16 dial_num;
            dial_num = ui->dial->value();
            if(dial_num<0)
            {
                dial_num = 0-dial_num;
                cmd[4] = 3;
            }
            else
                cmd[4] = 4;

            char dial_num_h = (char)((dial_num & 0xFF00) >>8);
            char dial_num_l = (char)(dial_num & 0x00FF);
            cmd[5] = dial_num_l;
            cmd[6] = dial_num_h;

            qDebug()<<"cmd:turn"<<cmd;
            //write to comport;
            if(ComPort->isOpen())
                ComPort->write(cmd,7);
        }
        else
        {
            qint16 slider_num;
            slider_num = ui->verticalSlider->value();
            if(slider_num!=0)
            {
                if(slider_num>0)
                    cmd[4]=1;
                else if(slider_num<0)
                {
                    cmd[4]=2;
                    slider_num = 0-slider_num;
                }
                char slider_num_h = (char)((slider_num & 0xFF00)>>8);
                char slider_num_l = (char)(slider_num & 0x00ff);
                cmd[5] = slider_num_l;
                cmd[6] = slider_num_h;
            }
            else
            {
                cmd[4]=0x0f;
                cmd[5]=0x0f;
                cmd[6]=0x0f;
            }
        }
    }

    qDebug()<<"cmd:dir"<<(signed short)cmd[6]<<' '<<(signed short)cmd[5];
    if(ComPort->isOpen())
        ComPort->write(cmd,7);

}


void MainWindow::on_dial_valueChanged(int value)
{
    turn = true;
   // ui->verticalSlider->setValue(0);

}

void MainWindow::on_verticalSlider_valueChanged(int value)
{
    turn=false;
    //ui->dial->setValue(0);
}

void MainWindow::on_playback_clicked()
{
    cur_buf = buf1;
    count_up = 0;

    timer_playback = new QTimer(this);
    connect(timer_playback,SIGNAL(timeout()),this,SLOT(read_back()));
    timer_playback->start(50);
    timer_update.start(100);
    timer_update2.start(100);

    samples->clear();
    ysamples->clear();

    ui->textBrowser->insertPlainText("3D play back now!\n");
}
void MainWindow::read_back()
{

    if(count>0)
    {
        if(cur==1024)
        {
            if(cur_buf->next!=NULL)
            {
                cur_buf = cur_buf->next;
                cur = 0;
            }
            else
                qDebug()<<"Read Error";
        }
        memcpy(&ROLL,cur_buf->buf+cur,4);
        cur+=4;
        if(cur==1024)
        {
            if(cur_buf->next!=NULL)
            {
                cur_buf = cur_buf->next;
                cur = 0;
            }
            else
                qDebug()<<"Read Error";
        }
        memcpy(&PITCH,cur_buf->buf+cur,4);
        cur+=4;
        if(cur==1024)
        {
            if(cur_buf->next!=NULL)
            {
                cur_buf = cur_buf->next;
                cur = 0;
            }
            else
                qDebug()<<"Read Error";
        }
        memcpy(&YAW,cur_buf->buf+cur,4);
        cur+=4;
        count-=3;

        //put data into plot
        count_up++;
        samples->push_back(QPointF(count_up,ROLL));
        ysamples->push_back(QPointF(count_up,-YAW));

        x_data->setSamples(*samples);
        y_data->setSamples(*ysamples);
        ui->qwtwidget->curvex->setData(x_data);
        ui->qwtwidget->curvey->setData(y_data);
        if(count_up>1000)
        {
            samples->clear();
            ysamples->clear();
            count_up=0;
        }
        ui->qwtwidget->replot();

        qDebug()<<"R"<<ROLL<<"P"<<PITCH<<"Y"<<YAW<<"count"<<count;
     }
    else
    {
        //
        // count = count_up*3;
        samples->clear();
        ysamples->clear();
        //
        timer_playback->stop();
        timer_update.stop();
        timer_update2.stop();
        ui->textBrowser->insertPlainText("3D play back is over! \n");

    }
}

void MainWindow::on_stop_clicked()
{
    ui->verticalSlider->setValue(0);
    ui->dial->setValue(0);
    turn= false;

    for(int i=0;i<4;i++)
    {
        cmd[i]=(char)0xff;
    }
    cmd[4]=0x0f;
    cmd[5]=0x0f;
    cmd[6]=0x0f;

    if(ComPort->isOpen())
        ComPort->write(cmd,7);
}


void MainWindow::on_checkBox_toggled(bool checked)
{
    act=true;
}
