#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "win_qextserialport.h"
#include <QFile>
#include <QFileDialog>
#include <QMessageBox>
#include <QPixmap>
#include <QTextStream>
#include "glwindow.h"
#include "glwindow2.h"
#include "vary.h"
#include <QBasicTimer>
#include <QTimerEvent>
#include <math.h>
#include <QDebug>
#include <QTimer>
#include <QString>
#include "buffer.h"
#include <qwt_plot.h>
#include "plot.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
     void quat2euler(float wf,float xf, float yf, float zf,float *roll,float *pitch,float *yaw);
    //buffer buf1;

private slots:
    void on_actionConnect_triggered();

    void on_actionDisconnect_triggered();

    void on_actionSave_triggered();

    void on_actionOpen_triggered();

    void on_actionQuit_triggered();

    void readComPort();  //read from serial port

    void on_clsc_clicked();

    void send_cmd();

    void on_dial_valueChanged(int value);

    void on_verticalSlider_valueChanged(int value);

    void on_playback_clicked();

    void read_back();

    void on_stop_clicked();

    void on_checkBox_toggled(bool checked);

protected:
public slots:
private:

    Ui::MainWindow *ui; //main UI
    Win_QextSerialPort* ComPort;  //serial port

    QByteArray temp;  //recent bytes get from serial port
    glwindow gldisplay; //widget display the 3D cube
    //vary test;             //connect with 3D rotation function, use setValue to change rotatition
    QTimer* timer_write;  //timer for serial port read and write
    QTimer* timer_read;
    QTimer* timer_playback;

    GLfloat roll;              //transition variable.
    GLfloat pitch;
    GLfloat yaw;

    QByteArray str1;

    char* text;
    long int text_size;
    long int income_size;

    plot* d_plot;

};

#endif // MAINWINDOW_H
