/*
 * Command.hpp
 *
 * Created: 2012/4/23 18:43:28
 *  Author: Andygongyb
 */ 


#ifndef COMMAND_HPP_
#define COMMAND_HPP_
#include <stdio.h>
#include "Omni.hpp"

typedef class CCommand {
private:

	typedef enum {
		FORWARD = 0x01,
		BACKWARD = 0x02,
		LEFT = 0x03,
		RIGHT = 0x04,
		SUSP = 0x05,
		STOP = 0x0F
	} cmd_t;

	char m_str[20];
	COmniDir* m_omni;

public:

	typedef enum {
		NO_CHANGE,
		ENABLE_SUSP,
		DISABLE_SUSP
	} susp_ctrl_t;

	CCommand(COmniDir* omni)
		: m_omni(omni) {
		strcpy(m_str, "no command");
	}
	
	susp_ctrl_t execute_cmd(uint8_t* buffer);
	
	uint8_t copy_cmd(char* str);
	
} *pCCommand;

#endif /* COMMAND_HPP_ */