/*
 * MPU6050.hpp
 *
 * Created: 2012/4/15 19:04:01
 *  Author: Andygongyb
 */ 


#ifndef MPU6050_HPP_
#define MPU6050_HPP_

#include "TWI_ASYN.hpp"
#include "EIC.hpp"
#include "FreeRTOS/FreeRTOS.h"
#include "FreeRTOS/semphr.h"

void sensor_handler(uint8_t int_num);

typedef class CMPU: public CTWIM_device {
private:
	static CMPU* m_instance;
	CMPU(void);
	
	uint8_t m_fifo_count_l;
	uint8_t m_packet[51];
	bool m_first;
	
	void bank_sel(uint8_t num);
	bool fifo_rdy(void);
	void dmp_init(void);
	
	xSemaphoreHandle m_mutex;
	
public:
	static CMPU* instance(void) {
		if (m_instance == NULL) {
			m_instance = new CMPU();
		}
		return m_instance;
	}
	
	~CMPU(void) {
		m_instance = NULL;
	}
	
	void update_package(void);
	
	void get_quaternion (int32_t buffer[4]);
	void get_rot_matrix(float rot[9]);
	void get_euler(float angles[3]);
	
	void auto_update(bool if_auto);
	
	friend void sensor_handler(uint8_t int_num);
} *pCMPU;



#endif /* MPU6050_HPP_ */