/*
 * Utility.cpp
 *
 *  Created on: Nov 21, 2011
 *      Author: Andygongyb
 */

#include "Utility.hpp"

char *itoa(int value, char *string, int radix) {
	char tmp[33];
	char *tp = tmp;
	int i;
	unsigned v;
	int sign;
	char *sp;

	if (radix > 36 || radix <= 1) {
		return NULL;
	}

	sign = (radix == 10 && value < 0);
	if (sign)
		v = -value;
	else
		v = (unsigned) value;
	while (v || tp == tmp) {
		i = v % radix;
		v = v / radix;
		if (i < 10)
			*tp++ = i + '0';
		else
			*tp++ = i + 'a' - 10;
	}

	if (string == 0)
		string = (char *) malloc((tp - tmp) + sign + 1);
	sp = string;

	if (sign)
		*sp++ = '-';
	while (tp > tmp)
		*sp++ = *--tp;
	*sp = 0;
	return string;
}

char *ltoa(long value, char *string, int radix) {
	char tmp[33];
	char *tp = tmp;
	long i;
	unsigned long v;
	int sign;
	char *sp;

	if (radix > 36 || radix <= 1) {
		return NULL;
	}

	sign = (radix == 10 && value < 0);
	if (sign)
		v = -value;
	else
		v = (unsigned long) value;
	while (v || tp == tmp) {
		i = v % radix;
		v = v / radix;
		if (i < 10)
			*tp++ = i + '0';
		else
			*tp++ = i + 'a' - 10;
	}

	if (string == 0)
		string = (char *) malloc((tp - tmp) + sign + 1);
	sp = string;

	if (sign)
		*sp++ = '-';
	while (tp > tmp)
		*sp++ = *--tp;
	*sp = 0;
	return string;
}

char *ultoa(unsigned long value, char *string, int radix) {
	char tmp[33];
	char *tp = tmp;
	long i;
	unsigned long v = value;
	char *sp;

	if (radix > 36 || radix <= 1) {
		return NULL;
	}

	while (v || tp == tmp) {
		i = v % radix;
		v = v / radix;
		if (i < 10)
			*tp++ = i + '0';
		else
			*tp++ = i + 'a' - 10;
	}

	if (string == 0)
		string = (char *) malloc((tp - tmp) + 1);
	sp = string;

	while (tp > tmp)
		*sp++ = *--tp;
	*sp = 0;
	return string;
}

void delay_ms_auto(uint32_t ms) {
	if (xTaskGetSchedulerState() == taskSCHEDULER_RUNNING) {
		vTaskDelay(ms);
	} else {
		cpu_delay_ms(ms, F_CPU);
	}
}