/*
 * adc.c
 *
 * Created: 2012/4/22 1:15:28
 *  Author: Andygongyb
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "adc.h"
#include "worm.h"

adc_property_t adc_property = {{140U, 250U}};
static uint16_t adc_value = 0x3FF;

void adc_init(void) {
	cli();
	ADMUX = 0x06;
	ADCSRA = _BV(ADEN) | _BV(ADSC) | _BV(ADFR) | _BV(ADIE) | _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);
	sei();
}

uint16_t adc_get(void) {
	return adc_value;
}

ISR(ADC_vect, ISR_NOBLOCK) {
	adc_value = ADC;
	if (adc_value < adc_property.property.adc_l_thr) {
		if (worm_dis_down == 0) {
			if (worm_state == WORM_DOWN) {
				worm_break();
			}			
			worm_dis_down = 1;			
		}
	} else if (adc_value > adc_property.property.adc_h_thr) {
		if (worm_dis_up == 0) {
			if (worm_state == WORM_UP) {
				worm_break();
			}
			worm_dis_up = 1;
		}
	} else {
		worm_dis_down = 0;
		worm_dis_up = 0;
	}
}