#ifndef UTILITY_HPP_
#define UTILITY_HPP_

#include <stdint.h>
#include <stdlib.h>

#define portENTER_THREAD_SAFE() portENTER_CRITICAL()
#define portEXIT_THREAD_SAFE() portEXIT_CRITICAL()

#define portENTER_CRITICAL()		__asm__ __volatile__ ( "in		__tmp_reg__, __SREG__" :: );	\
		__asm__ __volatile__ ( "cli" :: );								\
		__asm__ __volatile__ ( "push	__tmp_reg__" :: )

#define portEXIT_CRITICAL()			__asm__ __volatile__ ( "pop		__tmp_reg__" :: );				\
		__asm__ __volatile__ ( "out		__SREG__, __tmp_reg__" :: )

typedef struct {
	uint8_t b0 :1;
	uint8_t b1 :1;
	uint8_t b2 :1;
	uint8_t b3 :1;
	uint8_t b4 :1;
	uint8_t b5 :1;
	uint8_t b6 :1;
	uint8_t b7 :1;
} byte_t;

typedef struct {
	volatile uint8_t *ddr;
	volatile uint8_t *port;
	volatile uint8_t *pin;
	uint8_t pin_no;
} io_set;

extern "C" {

void __cxa_pure_virtual(void);
__extension__ typedef int __guard __attribute__((mode (__DI__)));
int __cxa_guard_acquire(__guard *);
void __cxa_guard_release(__guard *);
void __cxa_guard_abort(__guard *);
void atexit(void);

}

void* operator new(size_t size);
void operator delete(void * ptr);
/// Placement new for allocating the object inside a given memory buffer.
void* operator new(size_t, void* const buff);
/// Placement delete called automatically on "placement new" failure.
void operator delete(void *p, void* const buff);

#endif
